from tkinter import ttk
from tkinter import BOTH, END, LEFT
import tkinter as tk
from tkinter import messagebox as msg
from include import my_conn as my_con
my_conn=my_con.x()# for MySQL or SQLite 
def my_list():
    my_w = tk.Tk()
    my_w.geometry("1200x500") 
    my_w.title("www.plus2net.com")  
    global p_name
    global cat1,cat2
    cat1={1: 'Fruits', 2: 'Vegetable', 3: 'Games', 4: 'Vehicles'} # list of categories
    cat2={1:'Alex',2:'Ron',3:'Raju',4:'Ravi',5:'King'} # suppliers 
# Using treeview widget
    trv = ttk.Treeview(my_w, selectmode ='browse')
    trv.grid(row=1,column=1,padx=20,pady=20,rowspan=10)
# number of columns
    trv["columns"] = ("1", "2", "3","4","5","6","7","8")
  
# Defining heading
    trv['show'] = 'headings'
  
# width of columns and alignment 
    trv.column("1", width = 10, anchor ='w')
    trv.column("2", width = 10, anchor ='w')
    trv.column("3", width = 200, anchor ='w')
    trv.column("4", width = 100, anchor ='w')
    trv.column("5", width = 15, anchor ='w')
    trv.column("6", width = 250, anchor ='w')
    trv.column("7", width = 50, anchor ='e')
    trv.column("8", width = 70, anchor ='e')
# Headings  
# respective columns
    trv.heading("1", text ="p_id")
    trv.heading("2", text ="c_id")
    trv.heading("3", text ="p_name")
    trv.heading("4", text ="Size")
    trv.heading("5", text ="sup")  
    trv.heading("6", text ="Details")
    trv.heading("7", text ="Stock")
    trv.heading("8", text ="Price")
    def display_data():
        for i in trv.get_children(): 
                trv.delete(i) # remove all records of treeview
        # getting data from MySQL student table 
        r_set=my_conn.execute('SELECT * from plus2_inv_products')
        for dt in r_set: 
            trv.insert("", 'end',iid=dt[0], text=dt[0],
                values =(dt[0],dt[1],dt[2],dt[3],dt[4],dt[5],dt[6],dt[7]))
####
    l1=tk.Label(my_w,text='category')
    l1.grid(row=1,column=2)

    opt1=tk.StringVar()
    c_id = tk.OptionMenu(my_w,opt1, *cat1.values())
    c_id.grid(row=1,column=3,sticky='w')

    l2=tk.Label(my_w,text='Product')
    l2.grid(row=2,column=2)

    p_name=tk.Text(my_w,height=2,width=20)
    p_name.grid(row=2,column=3,columnspan=2,sticky='w')

    l3=tk.Label(my_w,text='Size')
    l3.grid(row=3,column=2,sticky='w')
    size_str=tk.StringVar()
    size=tk.Entry(my_w,width=20,textvariable=size_str)
    size.grid(row=3,column=3,columnspan=2,sticky='w')


    l4=tk.Label(my_w,text='Supplier')
    l4.grid(row=4,column=2)
    opt2=tk.StringVar()
    sup = tk.OptionMenu(my_w, opt2,*cat2.values())
    sup.grid(row=4,column=3,columnspan=2,sticky='w')

    l5=tk.Label(my_w,text='Details')
    l5.grid(row=5,column=2,sticky='w')

    details=tk.Text(my_w,width=20,height=2)
    details.grid(row=5,column=3,sticky='w')
    l6=tk.Label(my_w,text='Stock')
    l6.grid(row=6,column=2,sticky='w')
    stock_str=tk.StringVar()
    stock = tk.Spinbox(my_w, from_= 0, to = 10,width=4,textvariable=stock_str)
    stock.grid(row=6,column=3,sticky='w')
    
    l7=tk.Label(my_w,text='Price')
    l7.grid(row=7,column=2,sticky='w')
    price_str=tk.StringVar()
    price=tk.Entry(my_w,width=5,textvariable=price_str)
    price.grid(row=7,column=3,sticky='w')
    def data_collect(*args):
        if(trv.selection()[0]):
            p_id = trv.selection()[0]
            global p_name
            data_reset() # reset all inputs 
            query='SELECT * FROM plus2_inv_products WHERE p_id='+str(p_id)
            data=my_conn.execute(query)
            row = data.fetchone()
            opt1.set(cat1[row[1]])
            p_name.insert(tk.END,row[2])
            size_str.set(row[3])
            opt2.set(cat2[row[4]])
            details.insert(tk.END,row[5])
            stock_str.set(row[6])
            price_str.set(row[7])
            b1_update.config(state='normal')  #update button      
            b2_delete.config(state='normal')  #delete button      
    def data_reset():
        p_name.delete('1.0',END) # remove data from product
        p_name.update()
        details.delete('1.0',END)    
        details.update()
        size_str.set('')
        opt1.set('')  # remove selection for category
        opt2.set('')  # remove selection for supplier
        stock_str.set(0) # set stock to zero 
        price_str.set('')# set price to blank 
        p_id=None 
        b1_update.config(state='disabled')  #update button      
        b2_delete.config(state='disabled')  #delete button              
    def data_update():
        global cat1,cat2,p_name
        p_id = trv.selection()[0] 
        for i,j in cat1.items(): # get c_id
            if j==opt1.get():
                c_id=i
                break  
        for i,j in cat2.items(): # get c_id
            if j==opt2.get():
                supplier=i
                break  
        #print(p_id,opt1.get(),p_name.get("1.0",END),size_str.get(),opt2.get(),details.get("1.0",END))       
        query="UPDATE plus2_inv_products SET \
            c_id=" +str(c_id) \
            +",p_name='" + p_name.get("1.0",'end-1c') \
            +"',size='"+ size_str.get() \
            +"',supplier=" +str(supplier) \
            +",details= '"+ details.get("1.0",'end-1c')  \
            +"',stock="+ str(stock_str.get())\
            +",price="+ str(price_str.get()) \
            + " WHERE p_id=" + p_id
        id=my_conn.execute(query)
        #print("Row updated  = ",id.rowcount) 
        if(id.rowcount==1):
            data_reset()
            display_data()
########### Delete data #####
    def data_delete():
        p_id = trv.selection()[0] 
        my_var=msg.askyesno("Delete Product","Delete this product ?",default='no')
        if(my_var):
            query="DELETE FROM  plus2_inv_products WHERE p_id=" + p_id
            id=my_conn.execute(query)
            #print("Row updated  = ",id.rowcount) 
            if(id.rowcount==1):
                data_reset()
                display_data()
########### Delete data end ###             
    trv.bind("<<TreeviewSelect>>", data_collect)  
    #trv.bind("<ButtonRelease-1>",data_collect)            
    b1_update=tk.Button(my_w,text='Update',command=lambda:data_update(),state='disabled')
    b1_update.grid(row=11,column=2)
    b2_delete=tk.Button(my_w,text='Delete',command=lambda:data_delete(),state='disabled')
    b2_delete.grid(row=11,column=3)
    display_data()
    my_w.mainloop()
my_list()