from tkinter import ttk
from tkinter import BOTH, END, LEFT
import tkinter as tk
from sqlalchemy.exc import SQLAlchemyError
from include import my_conn as my_con
my_conn=my_con.x()
def my_list():
    my_w = tk.Tk()
    my_w.geometry("380x420") 
    my_w.title("www.plus2net.com")  
    global p_name
    global cat1,cat2
    font1=('Times',24,'normal')
    font2=('Times',40,'bold')
    cat1={1: 'Fruits', 2: 'Vegetable', 3: 'Games', 4: 'Vehicles'} # list of categories
    cat2={1:'Alex',2:'Ron',3:'Raju',4:'Ravi',5:'King'} # suppliers 
# Using treeview widget
    l0=tk.Label(my_w,text='Add Products',font=font2)
    l0.grid(row=0,column=1,columnspan=2,padx=10,sticky='e')
    l1=tk.Label(my_w,text='category',font=font1,fg='blue')
    l1.grid(row=1,column=1,padx=5)

    opt1=tk.StringVar()
    c_id = tk.OptionMenu(my_w,opt1, *cat1.values())
    c_id.grid(row=1,column=2,sticky='w')

    l2=tk.Label(my_w,text='Product',font=font1,fg='blue')
    l2.grid(row=2,column=1)

    p_name=tk.Text(my_w,height=2,width=20)
    p_name.grid(row=2,column=2,columnspan=2,sticky='w')

    l3=tk.Label(my_w,text='Size',font=font1,fg='blue')
    l3.grid(row=3,column=1,sticky='w',padx=30)
    size_str=tk.StringVar()
    size=tk.Entry(my_w,width=20,textvariable=size_str)
    size.grid(row=3,column=2,columnspan=2,sticky='w')


    l4=tk.Label(my_w,text='Supplier',font=font1,fg='blue')
    l4.grid(row=4,column=1,padx=10)
    opt2=tk.StringVar()
    sup = tk.OptionMenu(my_w, opt2,*cat2.values())
    sup.grid(row=4,column=2,columnspan=2,sticky='w')

    l5=tk.Label(my_w,text='Details',font=font1,fg='blue')
    l5.grid(row=5,column=1,sticky='w',padx=27)
    details=tk.Text(my_w,width=20,height=2)
    details.grid(row=5,column=2,sticky='w')
    l6=tk.Label(my_w,text='Stock',font=font1)
    l6.grid(row=6,column=1,padx=20,sticky='w')
    stock_str=tk.StringVar()
    stock = tk.Spinbox(my_w, from_= 0, to = 10,width=4,textvariable=stock_str)
    stock.grid(row=6,column=2,sticky='w')
    
    l7=tk.Label(my_w,text='Price',font=font1)
    l7.grid(row=7,column=1,padx=20,sticky='w')
    price_str=tk.StringVar()
    price=tk.Entry(my_w,width=5,textvariable=price_str)
    price.grid(row=7,column=2,sticky='w')

    b2=tk.Button(my_w,text='Add Data ',command=lambda:data_update())
    b2.grid(row=8,column=1)
    l6_str=tk.StringVar()
    l6=tk.Label(my_w,textvariable=l6_str)
    l6_str.set('status here')
    l6.grid(row=9,column=1,columnspan=2)
    
    def data_update():
        global cat1,cat2,p_name
        for i,j in cat1.items(): # get c_id
            if j==opt1.get():
                c_id=i
                break  
        for i,j in cat2.items(): # get c_id
            if j==opt2.get():
                supplier=i
                break  
        #print(p_id,opt1.get(),p_name.get("1.0",END),size_str.get(),opt2.get(),details.get("1.0",END))       
        try:
            query="INSERT INTO  plus2_inv_products \
            (c_id,p_name,size,supplier,details,stock,price) values( \
            " +str(c_id) \
            +",'" + p_name.get("1.0",'end-1c') \
            +"','" + size_str.get() \
            +"',"+ str(supplier) \
            +",'"+ details.get("1.0",'end-1c') \
            +"',"  + str(stock_str.get()) \
            + "," + str(price_str.get()) +  ")"
            #print(query)
            id=my_conn.execute(query)
            #print("Row added   = ",id.lastrowid) 

            if(id.lastrowid>0):
                p_name.delete('1.0',END)    
                p_name.update()
                details.delete('1.0',END)    
                details.update()
                size_str.set('')
                opt1.set('')
                opt2.set('')
                stock_str.set(0)
                price_str.set(0)
                p_id=None
                l6.config(fg='green') # foreground color 
            #l6.config(bg='white') # background color
                l6_str.set("ID:" + str(id.lastrowid))
                l6.after(3000,lambda:l6_str.set(''))
        except SQLAlchemyError as e:
            error = str(e.__dict__['orig'])
            l6.config(fg='red')
            l6_str.set("error "+ error)
            l6.after(3000,lambda:l6_str.set(''))
    my_w.mainloop()
my_list()