from sqlalchemy import create_engine
my_conn = create_engine("sqlite:///D:\\testing\\plus2_inventory_management_v1\\plus2_inventory.db")
from sqlalchemy.exc import SQLAlchemyError
try:
    my_conn.execute('''
       CREATE TABLE IF NOT EXISTS `plus2_inv_products` (
  `p_id` INTEGER PRIMARY KEY AUTOINCREMENT,
  `c_id` int(4) NOT NULL,
  `p_name` varchar(50) NOT NULL,
  `size` varchar(50) NOT NULL,
  `supplier` int(3) NOT NULL,
  `details` varchar(100) NOT NULL,
  `stock` int(3) NOT NULL,
  `price` int(6) NOT NULL  
);''')  
except SQLAlchemyError as e:
  #print(e)
  error = str(e.__dict__['orig'])
  print(error)
else:
  print("Product Table created successfully..")
###### adding data ####
try:
    my_conn.execute('''
       INSERT INTO `plus2_inv_products` (`p_id`, `c_id`, `p_name`, `size`, `supplier`, `details`, `stock`, `price`) VALUES
(1, 2, 'Bread Big Pack', '50 Pieces ', 3, 'Packed healthy bread', 6, 50),
(2, 1, 'Apple best quality', '12 Nos', 2, '12 Nos of best quality apple in one pack', 7, 4),
(3, 3, 'Tennis Racket with cover ', '1 packet ', 2, 'Best quality tennis racket with one set of balls', 7, 3),
(4, 3, 'Milk one litter bottle 2224567', '1 liter only 2', 4, 'Bottle packed 1 liter milk', 8, 10),
(5, 1, 'Onion packed 1 kg Medium quality', '1 KG only ', 2, 'One kg packed Onion of medium quality', 6, 7),
(6, 2, 'Potato 1 kg Pack', '2 Kg', 5, 'One kg pack of good quality', 9, 2),
(7, 4, '100 CC bike  Petrol', 'two seater ', 3, 'Petrol driven ', 6, 800),
(8, 2, 'Tnnis ball cans', 'Pack of 3 balls ', 4, 'Packed in cans ', 7, 20),
(9, 3, 'Cricket Bat ', 'Big size', 5, 'One bat in packed packet', 5, 5),
(10, 4, 'Car of 1000 cc	', '100 cc ', 3, 'Good brand car for booking only', 7, 10000),
(11, 3, 'Table tennis racket\n', 'Medium size', 2, 'Pack containing two rackets ', 10, 400),
(12, 2, 'Brinjal Pack ', '1 KG', 3, 'Freshly packed medium size\n', 7, 50);''')  
except SQLAlchemyError as e:
  #print(e)
  error = str(e.__dict__['orig'])
  print(error)
else:
  print("Data Added successfully..")

